unit fdDialog;

interface

uses
  LCLIntf, LCLType, SysUtils, Classes, Graphics, Dialogs,
  Controls, Forms, StdCtrls, Buttons, ExtCtrls;

type
  TDlgResult=(dlgYes,dlgNo);
  function AskYN (const txt: string): boolean;

type
TDialog = class(TForm)
  lblFrage: TLabel;
  pnlButtons: TPanel;
  procedure BitBtnClick(Sender: TObject);
private
  dlgResult: TdlgResult;
end;

var
dlg: TDialog;

implementation

{$R *.lfm}

///////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
//  Onclick
//
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


procedure TDialog.BitBtnClick(Sender: TObject);
begin
dlgResult:=TDlgResult(TBitBtn(Sender).Tag);
ModalResult:=mrOK; // beliebig, wird nicht verwendet. Die Zuweisung
                   // dient nur dazu, den modalen Dialog zu schliessen
showmessage ('Button '+TBitBtn(Sender).Caption+' wurde aktiviert');
end;


///////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
//
//  Buttons erzeugen
//
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


Procedure DlgSetStdButtons;
var
  B:TBitBtn;

    procedure DlgAddButton;
    begin
      B:=TBitBtn.Create(dlg.pnlButtons);
      B.Parent:=dlg.pnlButtons;
      B.Autosize:=true;
      B.OnClick:=@dlg.BitBtnClick;
    end;

begin
  DlgAddButton;
  B.Caption:='Nein';
  B.Tag:=ord(dlgNo);
  B.Left:=20;
  DlgAddButton;
  B.Caption:='Ja';
  B.Tag:=ord(dlgYes);
  B.Left:=80;
  B.Default:=true;
end;


////////////////////////////////////////////////////////////////////////////////
//
//  Dialog-Aufrufe
//
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function AskYN (const txt: string): boolean;
begin
  Application.Createform(TDialog, dlg);  // erzeugt das Dialogformular
  DlgSetStdButtons;                      // erzeugt die beiden Buttons
  dlg.lblFrage.Caption:=txt;             // setzt den Fragetext
  dlg.ShowModal;
  result:=dlg.dlgResult=dlgYes;          // liefert boolean Wert
end;

end.






